; These LSystems are designed to be run from FRACTINT.  No compilation is
; necessary, just copy this file to the FRACTINT directory and run FRACTINT.
; Select the lsystem fractal type and press F6 to select a file.


SpiralTile { ; by Herb Savage
; based on Martin Gardner's "Penrose Tiles to Trapdoor Ciphers"
  angle 16
  axiom X++X++X++X++|G|X++X++X++X
  X=[C12FX+++++@.7653668647C10F@I.7653668647[-----Y]+++++C12F]
  Y=[C12F+++++@.7653668647C10F@I.7653668647[-----Y]+++++C12F]
  }

VoderbergTile { ; by Herb Savage
; based on Martin Gardner's "Penrose Tiles to Trapdoor Ciphers",
; A spiral tiling by Heinz Voderberg
  angle 30
  axiom \84.1A\96@4.783386117M@I4.783386117/96A
  A=X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12X\12Z
  X=[D\78D\46.37236@3.393427D@I3.393427/46.37236D\114[\168X\24Y]D\78D\46.37236@3.393427D@I3.393427/46.37236D/78D]
  Y=[D\78D\46.37236@3.393427D@I3.393427/46.37236D/78D\168[\192Y]D\78D\46.37236@3.393427D@I3.393427/46.37236D]
  Z=[D\78D\46.37236@3.393427D@I3.393427/46.37236D\114D\78D\46.37236@3.393427D@I3.393427/46.37236D/78D]
  }

; These two aren't tilings but simple spiral patterns done by my 12 year old
; son Morgan that really need the warning from "Fractal Creations" about
; color cycling introducing hypnotic states.

Vertigo1 { ; by Morgan Savage
; Try order 13 and color cycle in both 256 and 16 color modes
  Angle 46
  Axiom X
  X=X>1F+@.9997X
  }

Vertigo2 { ; by Morgan Savage
; Try order 13 and color cycle in both 256 and 16 color modes
  Angle 49
  Axiom X
  X=X>1F+@.9997X
  }

