#include"dos.h"
#include"conio.h"

#define MAXITERS 100
#define INFINITY 30000

/*
   O.K., Here's the way it works:
   z is a complex number represented by
   zx and zy.  In order to get the mandelbrot
   set, we gotta square z and add c, represented
   by a and b, and feed it back into z.

   The Mandelbrot set is the set of c's that don't
   cause z to go to infinity, set here as a
   ridiculously low 30000.
*/

void initmode(int);

void main(void)
{
  double a,b,zx,zy,rx,ry;
  int c,q,d,e;
  initmode(0x13);
  for(d=0; d<319; d++)
    for(e=0; e<199; e++)
    {
      a=(double)(d-160)/80;  /* set up real part of c */
      b=(double)(e-100)/50;  /* set up imaginary part of c */
      c=0;
      q=0;
      zx=0;
      zy=0;
      while(c<MAXITERS && q==0)
      {
	rx=zx*zx-zy*zy+a;    /* real part of z*z+c */
	ry=2*zx*zy+b;        /* imaginary part of z*z+c */
	zx=rx;               /* feed it back in */
	zy=ry;
	c++;                 /* increment iteration counter */
	if(rx>INFINITY || ry>INFINITY) q=1;
      }
      if(c>=MAXITERS) c=0;    /* did it go to infinity? If so, make it black */
      pokeb(0xa000,d+e*320,c);
    }
  while(!kbhit());
  initmode(3);
}

void initmode(int mode)
{
  REGS regs;
  regs.x.ax=mode;
  int86(0x10,&regs,&regs);
}