#include"dos.h"
#include"conio.h"

#define MAXITERS 63
#define INFINITY 30000

/* O.K. here's what's different form the last:
     There is now a setpal function to set the
   grayscale palette.
*/

int mx=0,my=0;

void initmode(int);
void setpal(unsigned char, unsigned char, unsigned char, unsigned char);
int getmouse(void);
void setupmouse(void);
void showmouse(void);
void hidemouse(void);

void main(void)
{
  float a,b,zx,zy,rx,ry,shiftx=0,shifty=0,scalex=1,scaley=1;
  int c,q,d,e,q1=0;
  initmode(0x13);
  for(d=0; d<255; d++)       /* set up palette */
    setpal(d-1,d/4,d/4,d/4);
  setupmouse();
  while(q1==0)
  {
    for(d=0; d<319; d++)
      for(e=0; e<199; e++)
      {
	a=(((double)(d-160)/80)+shiftx)*scalex;  /* set up real part of c */
	b=(((double)(e-100)/50)+shifty)*scaley;  /* set up imaginary part of c */
	c=0;
	q=0;
	zx=0;
	zy=0;
	while(c<MAXITERS && q==0)
	{
	  rx=zx*zx-zy*zy+a;    /* real part of z*z+c */
	  ry=2*zx*zy+b;        /* imaginary part of z*z+c */
	  zx=rx;               /* feed it back in */
	  zy=ry;
	  c++;                 /* increment iteration counter */
	  if(rx>INFINITY || ry>INFINITY) q=1;
	}
	if(c>=MAXITERS) c=0;    /* did it go to infinity? If so, make it black */
	if(c!=0) pokeb(0xa000,d+e*320,c*4);
      }
    showmouse();
    while(!(c=getmouse()));
    hidemouse();
    if(c==2) q1=1;
    shiftx+=(((mx/2)-160)/80)*scalex*2;
    shifty+=(((my)-100)/50)*scaley*2;
    scalex*=.5;
    scaley*=.5;
  }
  initmode(3);
}

void initmode(int mode)
{
  union REGS regs;
  regs.x.ax=mode;
  int86(0x10,&regs,&regs);
}

void setpal(unsigned char c,unsigned char r, unsigned char g, unsigned char b)
{
  outportb(0x3c7,c);
  outportb(0x3c9,r);
  outportb(0x3c9,g);
  outportb(0x3c9,b);
}

int getmouse(void)
{
  union REGS regs;
  regs.x.ax=3;
  int86(0x33,&regs,&regs);
  mx=regs.x.cx;
  my=regs.x.dx;
  return regs.x.bx;
}

void setupmouse(void)
{
  union REGS regs;
  regs.x.ax=7;
  regs.x.cx=0;
  regs.x.dx=623;
  int86(0x33,&regs,&regs);
  regs.x.ax=8;
  regs.x.cx=0;
  regs.x.dx=189;
  int86(0x33,&regs,&regs);
/*  regs.x.ax=4;
  regs.x.cx=160;
  regs.x.dx=100;
  int86(0x33,&regs,&regs); */
}

void showmouse(void)
{
  union REGS regs;
  regs.x.ax=1;
  int86(0x33,&regs,&regs);
}

void hidemouse(void)
{
  union REGS regs;
  regs.x.ax=2;
  int86(0x33,&regs,&regs);
}