#include"dos.h"
#include"conio.h"

#define MAXITERS 63
#define INFINITY 3000
#define NUMDOTS 100

/* O.K. here's what's different form the last:
     There is now a setpal function to set the
   grayscale palette.
*/

int mx=0,my=0;

void initmode(int);
void setpal(unsigned char, unsigned char, unsigned char, unsigned char);
int getmouse(void);
void setmouse(int,int);
void setupmouse(void);
void showmouse(void);
void hidemouse(void);

void main(void)
{
  float a,b,zx,zy,rx,ry;
  int c,q,d,e,q1=0,px[NUMDOTS],py[NUMDOTS],pc[NUMDOTS],omx,omy,mc=0,omc;
  initmode(0x13);
  for(d=0; d<255; d++)       /* set up palette */
    setpal(d-1,d/4,d/4,d/4);
  setupmouse();
  for(d=0; d<NUMDOTS; d++)
  {
    px[d]=0;
    py[d]=0;
    pc[d]=0;
  }
    for(d=0; d<319; d++)
      for(e=0; e<199; e++)
      {
	a=(double)(d-160)/80;  /* set up real part of c */
	b=(double)(e-100)/50;  /* set up imaginary part of c */
	c=0;
	q=0;
	zx=0;
	zy=0;
	while(c<MAXITERS && q==0)
	{
	  rx=zx*zx-zy*zy+a;    /* real part of z*z+c */
	  ry=2*zx*zy+b;        /* imaginary part of z*z+c */
	  zx=rx;               /* feed it back in */
	  zy=ry;
	  c++;                 /* increment iteration counter */
	  if(rx>INFINITY || ry>INFINITY) q=1;
	}
	if(c>=MAXITERS) c=0;    /* did it go to infinity? If so, make it black */
	if(c!=0) pokeb(0xa000,d+e*320,c*4);
      }
  while(q1==0)
  {
    omx=mx;
    omy=my;
    c=getmouse();
    if(c) q1=1;
    if(omx!=mx || omy!=my)
    {
      for(d=0; d<NUMDOTS; d++)
	pokeb(0xa000,px[d]+py[d]*320,pc[d]);
      pokeb(0xa000,omx+omy*320,mc);
      zx=0;
      zy=0;
      a=double(mx-160)/80;
      b=double(my-100)/50;
      omc=mc;
      mc=peekb(0xa000,mx+my*320);
      if(mc!=0) {mc=omc; mx=omx; my=omy; setmouse(mx,my);}
      else
      {
      for(d=0; d<NUMDOTS; d++)
      {
	rx=zx*zx-zy*zy+a;
	ry=2*zx*zy+b;
	zx=rx;
	zy=ry;
	px[d]=(zx*80+160);
	py[d]=(zy*50+100);
	if(px[d]<0) px[d]=0;
	if(px[d]>319) px[d]=319;
	if(py[d]<0) py[d]=0;
	if(py[d]>199) py[d]=199;
	if(zx>INFINITY || zy>INFINITY)
	{
	  e=d;
	  for(d=e; d<NUMDOTS; d++)
	  {
	    px[d]=0;
	    py[d]=0;
	    pc[d]=0;
	  }
	}
      }
      }
      for(d=0; d<NUMDOTS; d++)
      {
	pc[d]=peekb(0xa000,px[d]+py[d]*320);
      }
      for(d=0; d<NUMDOTS; d++)
      {
	pokeb(0xa000,px[d]+py[d]*320,253);
      }
      pokeb(0xa000,mx+my*320,128);

    }
  }
  initmode(3);
}

void initmode(int mode)
{
  union REGS regs;
  regs.x.ax=mode;
  int86(0x10,&regs,&regs);
}

void setpal(unsigned char c,unsigned char r, unsigned char g, unsigned char b)
{
  outportb(0x3c7,c);
  outportb(0x3c9,r);
  outportb(0x3c9,g);
  outportb(0x3c9,b);
}

int getmouse(void)
{
  union REGS regs;
  regs.x.ax=3;
  int86(0x33,&regs,&regs);
  mx=regs.x.cx;
  my=regs.x.dx;
  return regs.x.bx;
}

void setupmouse(void)
{
  union REGS regs;
  regs.x.ax=7;
  regs.x.cx=0;
  regs.x.dx=319;
  int86(0x33,&regs,&regs);
  regs.x.ax=8;
  regs.x.cx=0;
  regs.x.dx=199;
  int86(0x33,&regs,&regs);
  setmouse(160,100);
}
void setmouse(int x,int y)
{
  union REGS regs;
  regs.x.ax=4;
  regs.x.cx=x;
  regs.x.dx=y;
  int86(0x33,&regs,&regs);
}

