;NoGifLite v1.0 (C)Copyright 1993 R.Janorkar
;Freeware, no payment required for usage, however the author retains
;all rights to the source code.

;Locates the string GIFLITE within files, returns DOS ERRORLEVEL 1 if
;found, or 0 if not found. Syntax: NOGIFLIT <\path\file.gif>

;Use on BBSes in the upload scan batch file to catch the GIFLITED
;images - GIFLITE works by stripping out most of the GIF image,
;claiming it compresses the file! Avoid using GIFLITE, it's effects are
;irreversable.

;Used with MASM v5.10 and MS-Link v5.13 and EXE2COM v1.00

;Assemble and link the module, the use either EXE2BIN or EXE2COM on the
;EXEcutable file. Code might require modification for use with other
;assemblers/linkers.

_TEXT     SEGMENT WORD PUBLIC 'CODE'
          ASSUME   CS:_TEXT,DS:_TEXT,ES:_TEXT
          ORG   100h
start:
        JMP     BEGIN

FILENAME        DB      128 DUP(0)
F_HANDLE        DW      0
BANNER          DB      "NoGifLite v1.0 (C)1993 R.Janorkar FREEWARE",0Dh,0Ah
                DB      "Checks if GIFLITE has corrupted a GIF",0Dh,0Ah
                DB      "Returns ERRORLEVEL 0=OK, 1=BAD",0Dh,0Ah
                DB      "syntax NOGIFLIT <\path\file.gif>",0Dh,0Ah,24h
F_ERROR         DB      "File not found!",0Dh,0Ah,24h
R_ERROR         DB      "File read error!",0Dh,0Ah,24h
NO_LITE         DB      "Image is safe.",0Dh,0Ah,24h
YES_LITE        DB      "GIFLITE used!!! Image is damaged!",0Dh,0Ah,24h
SEARCH          DB      "GIFLITE"
READ_BUFF       DB      5000 DUP(0)

BEGIN:
        MOV     AX,CS           ;GET CODE SEGMENT
        MOV     ES,AX
        MOV     SI,0080h        ;READ COMMAND LINE FILE NAME
        LODSB           ;GET COUNTER
        XOR     CX,CX   ;ZERO COUNTER
        MOV     CL,AL   ;MOVE CHARACTER COUNT
        CMP     CL,0    ;IF ZERO NO COMMAND LINE
        JNZ     GET_NAME        ;SHOW ERROR

CMD_ERR:
        MOV     AX,ES           ;FIX DS
        MOV     DS,AX
        MOV     DX,OFFSET BANNER
        MOV     AH,09           ;SHOW STRING
        INT     21h
        MOV     AX,4C00h        ;RETURN 0
        INT     21h             ;QUIT

GET_NAME:
        MOV     DI,OFFSET CS:FILENAME
        LODSB           ;READ CHARACTER & DISCARD
        DEC     CX      ;ADJUST COUNTER
        JZ      CMD_ERR ;SHOW ERROR IF NO COMMAND LINE

FLUSH_SPACE:
        LODSB           ;GET CHARACTER
        CMP     AL,20h  ;IS IT SPACE?
        JNZ     READ_NAME1       ;THEN CONTINUE
        LOOP    FLUSH_SPACE     ;REPEAT
        JMP     SHORT CMD_ERR   ;IF NOT THEN COMMAND LINE ERROR

READ_NAME1:
        DEC     SI      ;ADJUST

READ_NAME:
        LODSB           ;READ CHARACTER
        CMP     AL,20h  ;IF SPACE END
        JZ      GOT_NAME
        CMP     AL,0Dh  ;OR EOL
        JZ      GOT_NAME
        STOSB                   ;SAVE CHARACTER
        LOOP    READ_NAME

GOT_NAME:
        MOV     AL,0            ;ADD STOPPER
        STOSB                   ;SAVE CHARACTER
        MOV     AX,ES
        MOV     DS,AX           ;RESTORE DS
        MOV     AX,3D00h        ;OPEN FILE READ ONLY
        MOV     DX,OFFSET FILENAME
        INT     21h             ;OPEN IT
        JNC     FILE_OPEN       ;CARRY ON ERROR
        MOV     DX,OFFSET F_ERROR       ;SHOW ERROR
        MOV     AH,09
        INT     21h
        MOV     AX,4C00h        ;RETURN 0
        INT     21h             ;QUIT

FILE_OPEN:
        MOV     WORD PTR F_HANDLE,AX
        MOV     BX,AX
        MOV     AH,3Fh        ;READ FROM FILE
        MOV     CX,5000         ;ONLY 5000 BYTES
        MOV     DX,OFFSET READ_BUFF
        INT     21h
        JNC     FILE_READ       ;CARRY ON ERROR
        MOV     BX,WORD PTR F_HANDLE
        MOV     AH,3Eh          ;CLOSE FILE
        INT     21h
        MOV     AH,09           ;SHOW ERROR
        MOV     DX,OFFSET R_ERROR
        INT     21h
        MOV     AX,4C00h        ;RETURN 0
        INT     21h             ;QUIT

FILE_READ:
        PUSH    AX              ;SAVE READ SIZE
        MOV     BX,WORD PTR F_HANDLE
        MOV     AH,3Eh          ;CLOSE FILE
        INT     21h

        POP     CX              ;GET READ SIZE
        MOV     SI,OFFSET READ_BUFF
        MOV     DI,OFFSET SEARCH

CHECK_LITE:
        LODSB                   ;GET CHARACTER
        CMP     AL,BYTE PTR ES:[DI]
        JZ      CHECK_ALL       ;IF MATCH CHECK REST
        LOOP    CHECK_LITE      ;REPEAT TILL ALL CHECKED

NO_LITE_FOUND:
        MOV     AH,09           ;SHOW MESSAGE
        MOV     DX,OFFSET NO_LITE
        INT     21h
        MOV     AX,4C00h        ;RETURN 0
        INT     21h             ;QUIT

CHECK_ALL:
        PUSH    DI
        PUSH    SI      ;SAVE POINTERS
        PUSH    CX
        INC     DI
        MOV     CX,6    ;6 MORE CHARACTERS
        REPZ    CMPSB   ;COMPARE FAST
        CMP     CX,0    ;ALL CHECKED?
        JZ      LITE_FOUND      ;YES, FOUND IT
        POP     CX      ;OR RESTORE
        POP     SI
        POP     DI
        LOOP    CHECK_LITE      ;REPEAT
        JMP     SHORT NO_LITE_FOUND     ;OR NOTHING FOUND IF END

LITE_FOUND:
        MOV     AH,09   ;SHOW MESSAGE
        MOV     DX,OFFSET YES_LITE
        INT     21h
        MOV     AX,4C01h        ;RETURN 1
        INT     21h             ;QUIT

_TEXT     ENDS

     END    start
